//
//  Cnotroller.m
//  Core Animation Test
//
//  Created by mkino on 11/26/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "Cnotroller.h"


@implementation Cnotroller

- (void)awakeFromNib
{
    // レイヤーを作成する
    CALayer* layer;
    layer = [CALayer layer];
    
    // CGImageを作成する
    NSBitmapImageRep*   bitmapImage;
    CGImageRef          image;
    bitmapImage = [NSBitmapImageRep imageRepWithContentsOfFile:@"/Library/Desktop Pictures/Nature/Earth.jpg"];
    image = [bitmapImage CGImage];
    
    // レイヤーに画像を設定する
    layer.contents = (id)image;
    layer.frame = CGRectMake(0, 0, 256, 160);
    
    // 背景レイヤーを作成する
    CALayer*    backgroundLayer;
    CGColorRef  blackColor;
    backgroundLayer = [CALayer layer];
    blackColor = CGColorCreateGenericGray(0, 1.0f);
    backgroundLayer.backgroundColor = blackColor;
    CGColorRelease(blackColor);
    
    // 画像レイヤーを背景レイヤーに追加する
    [backgroundLayer addSublayer:layer];
    
    // レイヤーをビューに設定する
    [_view setLayer:backgroundLayer];
    [_view setWantsLayer:YES];
}

- (IBAction)doAnimation:(id)sender
{
    // レイヤーを取得する
    CALayer*    layer;
    layer = [[[_view layer] sublayers] objectAtIndex:0];
    
    // アニメーションを作成する
    CABasicAnimation*   animation;
    animation = [CABasicAnimation animationWithKeyPath:@"opacity"];
    
    // アニメーションのプロパティを設定する
    animation.duration = 1.0f;
    animation.autoreverses = YES;
    animation.repeatCount = 4;
    animation.fromValue = [NSNumber numberWithFloat:1.0f];
    animation.toValue = [NSNumber numberWithFloat:0];
    
    // レイヤーにアニメーションを追加する
    [layer addAnimation:animation forKey:@"opacityAnimation"];
    
    // アニメーションを作成する
    animation = [CABasicAnimation animationWithKeyPath:@"position"];
    animation.duration = 1.0f;
    animation.autoreverses = YES;
    animation.repeatCount = 4;
    
    // アニメーションのプロパティを設定する
    CGPoint position;
    position = layer.position;
    animation.fromValue = [NSValue valueWithPoint:NSPointFromCGPoint(position)];
    position.x += 256;
    position.y += 160;
    animation.toValue = [NSValue valueWithPoint:NSPointFromCGPoint(position)];
    
    // レイヤーにアニメーションを追加する
    [layer addAnimation:animation forKey:@"positionAnimation"];
}

@end
